package dk.nsp.idsas.dao;

import org.apache.log4j.Logger;
import org.springframework.jdbc.core.JdbcTemplate;

import javax.sql.DataSource;

public class AlivenessDao {
	private static final Logger logger = Logger.getLogger(AlivenessDao.class);

	private final JdbcTemplate jdbcTemplate;

	public AlivenessDao(DataSource dataSource) {
		jdbcTemplate = new JdbcTemplate(dataSource);
	}

	public boolean isAlive() {
		try {
			jdbcTemplate.execute("select 1");
			return true;
		} catch (Exception e) {
			logger.error("Database does not respond", e);
			return false;
		}
	}
}
