package dk.nsp.idsas.security.model;

public class IdsasActor {
    private final IdsasActorType actorType;
    private final String actorId;
    private final String actorIdType;
    private final String clientSystemName;
    private final String clientKey;

    private IdsasActor(IdsasActorType actorType, String actorId, String actorIdType, String clientSystemName, String clientKey) {
        this.actorType = actorType;
        this.actorIdType = actorIdType;
        this.actorId = actorId;
        this.clientSystemName = clientSystemName;
        this.clientKey = clientKey;
    }

    public static IdsasActor createSundhedsFaglig(String actorId, String actorIdType) {
        return new IdsasActor(IdsasActorType.SUNDHEDSFAGLIG, actorId, actorIdType, "", "");
    }

    public static IdsasActor createSystem(String actorId, String actorIdType, String clientSystemName, String clientKey) {
        return new IdsasActor(IdsasActorType.SYSTEM, actorId, actorIdType, clientSystemName, clientKey);
    }

    public IdsasActorType getActorType() {
        return actorType;
    }

    public String getActorId() {
        return actorId;
    }

    public String getClientSystemName() {
        return clientSystemName;
    }

    public String getClientKey() {
        return clientKey;
    }

    public String getActorIdType() {
        return actorIdType;
    }

    public enum IdsasActorType {
        SUNDHEDSFAGLIG("Sundhedsfaglig"),
        SYSTEM("System");
        private final String actorType;
        IdsasActorType(String actorType) {
            this.actorType = actorType;
        }
        public String value() {
            return actorType;
        }
    }
}
