package dk.nsp.idsas.util;

import dk.nsp.idsas.service.IdsasServiceException;

import java.nio.ByteBuffer;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class HashingUtil {
    public static String createPatientIdHash(String patientId, byte[] salt) throws IdsasServiceException {
        byte[] patientIdByes = patientId.getBytes();
        byte[] combined = new byte[patientIdByes.length + salt.length];

        ByteBuffer buffer = ByteBuffer.wrap(combined);
        buffer.put(patientIdByes);
        buffer.put(salt);

        try {
            MessageDigest md = MessageDigest.getInstance("SHA-256");
            byte[] hashBytes = md.digest(buffer.array());
            return javax.xml.bind.DatatypeConverter.printHexBinary(hashBytes);
        } catch (NoSuchAlgorithmException e) {
            throw new IdsasServiceException(e.getMessage(), false);
        }
    }
}
