package dk.nsp.idsas.util;

import java.util.Comparator;
import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;

import dk.nsp.idsas.util.health.HealthIndicator;

public class HealthReportGenerator {
    public static String generateResult(List<HealthIndicator> healthIndicators) {
        String content = healthIndicators.stream()
                .map(indicator -> indicator.getHealthInfo().getText()).collect(Collectors.joining(", "));
        return String.format("{ %s }", content);
    }

    public static Integer generateStatus(List<HealthIndicator> healthIndicators) {
        return healthIndicators.stream()
                .map(indicator -> indicator.getHealthInfo().getStatus())
                .max(Comparator.comparing(Function.identity()))
                .orElse(200);
    }
}
