package dk.nsp.idsas.util.health;

import dk.nsp.idsas.dao.PatientIdSaltDao;
import dk.nsp.idsas.dao.SaltDao;
import dk.nsp.idsas.util.JsonPair;
import org.apache.commons.httpclient.HttpStatus;

public class PatientIdSaltHealthIndicator implements HealthIndicator {
    private final PatientIdSaltDao patientIdSaltDao;

    public PatientIdSaltHealthIndicator(PatientIdSaltDao patientIdSaltDao) {
        this.patientIdSaltDao = patientIdSaltDao;
    }

    @Override
    public HealthIndication getHealthInfo() {
        try {
            patientIdSaltDao.getLatestSalt();
            return new HealthIndication(HttpStatus.SC_OK, new JsonPair("PatientIdSalt", "OK"));
        } catch (Exception e) {
            return new HealthIndication(HttpStatus.SC_SERVICE_UNAVAILABLE, new JsonPair("PatientIdSalt", "Unavailable"));
        }
    }
}
