package dk.nsp.idsas.ws;

import dk.nsp.idsas.service.ServiceSetup;
import org.apache.log4j.Logger;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import static dk.nsp.idsas.service.ServiceSetup.ANNOTATION_CONFIG_CONTEXT;

public abstract class AbstractContextListener implements ServletContextListener {
	private static final Logger logger = Logger.getLogger(AbstractContextListener.class);

	@Override
	public void contextInitialized(ServletContextEvent event) {
		logger.trace("IdsasContextListener contextInitialized");
		AnnotationConfigApplicationContext applicationContext = new AnnotationConfigApplicationContext();
		applicationContext.register(ServiceSetup.class);
		applicationContext.register(getWebSetupClass());
		applicationContext.refresh();

		event.getServletContext().setAttribute(ANNOTATION_CONFIG_CONTEXT, applicationContext);
	}

	@Override
	public void contextDestroyed(ServletContextEvent sce) {
		Object ctx = sce.getServletContext().getAttribute(ANNOTATION_CONFIG_CONTEXT);
		if(ctx instanceof AnnotationConfigApplicationContext) {
			((AnnotationConfigApplicationContext)ctx).close();
		}
	}

	protected abstract Class<?> getWebSetupClass();
}
