package dk.nsp.idsas.dao;

import org.junit.Test;
import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;

import javax.sql.DataSource;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

public class AlivenessDaoTest extends AbstractDaoTest {
    @Autowired
    DataSource dataSource;

    @Test
    public void isAlive_WhenDatabaseIsResponding_ReturnsTrue() {
        AlivenessDao alivenessDao = new AlivenessDao(dataSource);

        assertTrue(alivenessDao.isAlive());
    }

    @Test
    public void isAlive_WhenDatabaseIsNotResponding_ReturnsFalse() {
        DataSource nonRespondingDataSource = Mockito.mock(DataSource.class);
        AlivenessDao alivenessDao = new AlivenessDao(nonRespondingDataSource);

        assertFalse(alivenessDao.isAlive());
    }
}