package dk.nsp.idsas.test.stepdefinitions;

import java.io.IOException;

import dk.nsp.idsas.test.util.HttpClient;
import io.cucumber.java.en.And;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.junit.Assert;
import org.springframework.beans.factory.annotation.Value;

public class CleanupStepDefinitions {
    @Value("${idsas.operations.endpoint}" + "/cleanup-blurrings")
    private String cleanupEndpoint;

    @Value("${idsas.operations.endpoint}" + "/status")
    private String operationsHealthEndpoint;

    private int responseCode;

    @When("oprydning af gamle sløringer igangsættes")
    public void oprydningAfGamleSløringerIgangsættes() throws IOException {
        HttpClient httpClient = new HttpClient();
        httpClient.get(cleanupEndpoint);
        responseCode = httpClient.getResponseCode();
    }

    @Then("oprydning af gamle sløringer giver returkode {int}")
    public void oprydningAfGamleSløringerGiverReturkode(int code) {
        Assert.assertEquals(code, responseCode);
    }

    @And("health endpoint indeholder ikke status {string}")
    public void healthEndpointHarIkkeLængereStatus(String status) throws IOException {
        HttpClient httpClient = new HttpClient();
        String response = httpClient.get(operationsHealthEndpoint);
        Assert.assertFalse(response.contains(status));
    }
}
