package dk.nsp.idsas.test.stepdefinitions;

import dk.nsp.idsas.test.util.HttpClient;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.junit.Assert;
import org.springframework.beans.factory.annotation.Value;

import java.io.IOException;

public class HealthStepDefinitions {
    @Value("${idsas.registration.endpoint}" + "/status")
    private String registrationHealthEndpoint;

    @Value("${idsas.lookup.endpoint}" + "/status")
    private String lookupHealthEndpoint;

    @Value("${idsas.salt.endpoint}" + "/status")
    private String saltHealthEndpoint;

    @Value("${idsas.operations.endpoint}" + "/status")
    private String operationsHealthEndpoint;

    private int responseCode;

    @When("Jeg tjekker registration servicens health endpoint")
    public void jegTjekkerRegistrationServicensHealthEndpoint() throws IOException {
        HttpClient httpClient = new HttpClient();
        httpClient.get(registrationHealthEndpoint);
        responseCode = httpClient.getResponseCode();
    }

    @When("Jeg tjekker lookup servicens health endpoint")
    public void jegTjekkerLookupServicensHealthEndpoint() throws IOException {
        HttpClient httpClient = new HttpClient();
        httpClient.get(lookupHealthEndpoint);
        responseCode = httpClient.getResponseCode();
    }

    @When("Jeg tjekker salt servicens health endpoint")
    public void jegTjekkerSaltServicensHealthEndpoint() throws IOException {
        HttpClient httpClient = new HttpClient();
        httpClient.get(saltHealthEndpoint);
        responseCode = httpClient.getResponseCode();
    }

    @When("Jeg tjekker operations servicens health endpoint")
    public void jegTjekkerOperationsServicensHealthEndpoint() throws IOException {
        HttpClient httpClient = new HttpClient();
        httpClient.get(operationsHealthEndpoint);
        responseCode = httpClient.getResponseCode();
    }

    @Then("Så burde jeg få et {int} OK tilbage")
    public void såBurdeJegFåEtOKTilbage(int expectedResponseCode) {
        Assert.assertEquals(expectedResponseCode, responseCode);
    }
}
