package dk.nsp.idsas.setup;

import dk.nsp.idsas.dao.SaltDao;
import dk.nsp.idsas.dao.WhitelistDao;
import dk.nsp.idsas.service.SaltService;
import dk.nsp.idsas.util.health.SaltHealthIndicator;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;
import org.springframework.context.annotation.PropertySources;

@Configuration
@PropertySources({
        @PropertySource("classpath:/META-INF/maven/dk.nsp.idsas/idsas-salt-web/pom.properties"),
        @PropertySource(value = "idsas-salt.properties", encoding = "ISO-8859-1")
        // Bemærkning: I Java 8 er properties altid i ISO-8859-1, men fremadrettet skulle de gerne kunne være UTF-8.
})
public class WebSetup {

    @Bean
    public SaltService saltService(SaltDao saltDao, WhitelistDao whitelistDao) {
        return new SaltService(saltDao, whitelistDao);
    }

    @Bean
    public SaltHealthIndicator saltHealthIndicator(SaltDao saltDao) {
        return new SaltHealthIndicator(saltDao);
    }

}
