package dk.nsp.idsas.util.health;

import dk.nsp.idsas.service.CleanupService;
import dk.nsp.idsas.util.JsonPair;
import org.apache.commons.httpclient.HttpStatus;

public class CleanupHealthIndicator implements HealthIndicator {
    private final CleanupService cleanupService;

    public CleanupHealthIndicator(CleanupService cleanupService) {
        this.cleanupService = cleanupService;
    }

    @Override
    public HealthIndication getHealthInfo() {
        return new HealthIndication(HttpStatus.SC_OK, new JsonPair("Blurring Cleanup Job Status", cleanupService.getStatus().finished.toString()));
    }
}
