package dk.nsp.idsas.util.health;

import dk.nsp.idsas.integrations.personinformation.PersonInformationClient;
import dk.nsp.idsas.util.JsonPair;

import org.apache.commons.httpclient.HttpStatus;

public class PersonInformationHealthIndicator implements HealthIndicator {

    private final PersonInformationClient personInformationClient;
    private final int errorTolerance;

    public PersonInformationHealthIndicator(PersonInformationClient personInformationClient, int errorTolerance) {
        this.personInformationClient = personInformationClient;
        this.errorTolerance = errorTolerance;
    }

    @Override
    public HealthIndication getHealthInfo() {
        return personInformationClient.getErrorCount() > errorTolerance
                ? new HealthIndication(HttpStatus.SC_SERVICE_UNAVAILABLE, new JsonPair("Person information service integration", "Unavailable"))
                : new HealthIndication(HttpStatus.SC_OK, new JsonPair("Person information service integration", "OK"));
    }
}
